<?php

namespace Drupal\disable_web_install;

use Drupal\Core\Url;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Disable web install class.
 */
final class DisableWebInstall {

  /**
   * Route mappings.
   *
   * @var array
   */
  public const ROUTE_MAPPINGS = [
    'update.module_install' => 'system.modules_list',
    'update.report_install' => 'update.status',
    'update.theme_install' => 'system.themes_page',
  ];

  /**
   * Redirect.
   */
  public static function redirect(string $redirect_route_name = '<front>'): RedirectResponse {
    return new RedirectResponse(Url::fromRoute($redirect_route_name)->toString());
  }

  /**
   * Menu link alter.
   */
  public static function menuLinkAlter(array &$links): void {
    foreach ($links as $route_name => $o) {
      foreach (self::ROUTE_MAPPINGS as $target_route_name => $unused) {
        if (preg_match('/(^|:)' . preg_quote($target_route_name) . '$/', $route_name)) {
          unset($links[$route_name]);
        }
      }
    }
  }

}
