<?php

namespace Drupal\disable_web_install\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\disable_web_install\DisableWebInstall;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  public function alterRoutes(RouteCollection $collection) {
    foreach (DisableWebInstall::ROUTE_MAPPINGS as $name => $redirect_route_name) {
      if (($route = $collection->get($name)) && $collection->get($redirect_route_name)) {
        $route->setDefaults([
          '_controller' => '\\Drupal\\disable_web_install\\DisableWebInstall::redirect',
          'redirect_route_name' => $redirect_route_name,
        ]);
      }
    }
  }

}
